package Comments::L10N::es;

use strict;
use warnings;
use utf8;
use base 'Comments::L10N';

our %Lexicon = (

## lib/MT/App/Comments.pm
    'Error assigning commenting rights to user \'[_1] (ID: [_2])\' for weblog \'[_3] (ID: [_4])\'. No suitable commenting role was found.' => 'Error asignando permisos para comentar al usuario \'[_1] (ID: [_2])\' para el weblog \'[_3] (ID: [_4])\'. No se encontró un rol adecuado.',
    'Cannot load blog #[_1].' => 'No se pudo cargar el blog #[_1].',
    'Invalid commenter login attempt from [_1] to blog [_2](ID: [_3]) which does not allow Movable Type native authentication.' => 'Intento de identificación de comentarista no válido desde [_1] en el blog [_2](ID: [_3]) que no permite la autentificación nativa de Movable Type.',
    'Invalid login.' => 'Acceso no válido.',
    'Invalid login' => 'Inicio de sesión no válido',
    'Successfully authenticated, but signing up is not allowed.  Please contact your Movable Type system administrator.' => 'Autentificado con éxito, pero el registro no está habilitado. Por favor, contacte con el administrador de sistemas de Movable Type.',
    'You need to sign up first.' => 'Primero identifíquese',
    'The login could not be confirmed because of a database error ([_1])' => 'No se pudo confirmar el acceso debido a un error de la base de datos ([_1])',
    'Permission denied.' => 'Permiso denegado.',
    'Login failed: permission denied for user \'[_1]\'' => 'Falló la identificación: permiso denegado al usuario \'[_1]\'',
    'Login failed: password was wrong for user \'[_1]\'' => 'Falló la identificación: contraseña errónea del usuario \'[_1]\'',
    'Failed login attempt by disabled user \'[_1]\'' => 'Intento fallido de inicio de sesión por un usuario deshabilitado \'[_1]\'',
    'Failed login attempt by unknown user \'[_1]\'' => 'Intento fallido de inicio de sesión por un usuario desconocido \'[_1]\'',
    'Signing up is not allowed.' => 'No está permitida la inscripción.',
    'Movable Type Account Confirmation' => 'Confirmación de cuenta - Movable Type',
    'Your confirmation has expired. Please register again.' => 'La confirmación caducó. Por favor, regístrese de nuevo.',
    '<a href="[_1]">Return to the original page.</a>' => '<a href="[_1]">Regresar a la página original.</a>',
    'Your confirmation have expired. Please register again.' => 'Su confirmación ha caducado. Por favor, regístrese de nuevo.',
    'Commenter \'[_1]\' (ID:[_2]) has been successfully registered.' => 'El comentarista \'[_1]\' (ID:[_2]) se inscribió con éxito.',
    'Thanks for the confirmation.  Please sign in to comment.' => 'Gracias por la confirmación. Por favor, identifíquese para comentar.',
    '[_1] registered to the blog \'[_2]\'' => '[_1] registrado en el blog \'[_2]\'',
    'No id' => 'Sin id',
    'No such comment' => 'No existe dicho comentario',
    'IP [_1] banned because comment rate exceeded 8 comments in [_2] seconds.' => 'IP [_1] bloqueada porque excedió el ritmo de comentarios, más de 8 en [_2] segundos.',
    'IP Banned Due to Excessive Comments' => 'IP bloqueada debido al exceso de comentarios',
    'No entry_id' => 'Sin entry_id',
    'No such entry \'[_1]\'.' => 'No existe la entrada \'[_1]\'.',
    '_THROTTLED_COMMENT' => 'Demasiados comentarios en un corto periodo de tiempo. Por favor, inténtelo dentro de un rato.',
    'Comments are not allowed on this entry.' => 'No se permiten comentarios en esta entrada.',
    'Comment text is required.' => 'El texto del comentario es obligatorio.',
    'An error occurred: [_1]' => 'Ocurrió un error: [_1]',
    'Registration is required.' => 'El registro es obligatorio.',
    'Name and E-mail address are required.' => 'El nombre y la dirección de correo son obligatorios.',
    'Invalid email address \'[_1]\'' => 'Dirección de correo-e no válida \'[_1]\'',
    'Invalid URL \'[_1]\'' => 'URL no válida \'[_1]\'',
    'Text entered was wrong.  Try again.' => 'El texto que introdujo es erróneo. Inténtelo de nuevo.',
    'Comment save failed with [_1]' => 'Fallo guardando comentario con [_1]',
    'Comment on "[_1]" by [_2].' => 'Comentario en "[_1]" por [_2].',
    'Publishing failed: [_1]' => 'Falló al publicar: [_1]',
    'Cannot load template' => 'No se pudo cargar la plantilla',
    'Failed comment attempt by pending registrant \'[_1]\'' => 'Falló el intento de comentar por el comentarista pendiente \'[_1]\'',
    'Registered User' => 'Usuario registrado',
    'Cannot load entry #[_1].' => 'No se pudo cargar la entrada #[_1].',
    'You are trying to redirect to external resources. If you trust the site, please click the link: [_1]' => 'Está intentando redireccionar hacia un recurso externo. Si confía en el sitio, haga clic en el enlace: [_1]',
    'No entry was specified; perhaps there is a template problem?' => 'No se especificó ninguna entrada; ¿quizás hay un problema con la plantilla?',
    'Somehow, the entry you tried to comment on does not exist' => 'De alguna manera, la entrada en la que intentó comentar no existe',
    'Invalid entry ID provided' => 'ID de entrada provisto no válido',
    'For improved security, please change your password' => 'Para mejorar la seguridad, por favor cambie su contraseña',
    'All required fields must be populated.' => 'Debe rellenar todos los campos obligatorios.',
    '[_1] contains an invalid character: [_2]' => '[_1] contiene un caracter no válido: [_2]',
    'Display Name' => 'Nombre público',
    'Passwords do not match.' => 'Las contraseñas no coinciden.',
    'Failed to verify the current password.' => 'Falló la verificación de la contraseña actual.',
    'Email Address is invalid.' => 'La dirección de correo no es válida.',
    'URL is invalid.' => 'La URL no es válida.',
    'Commenter profile has successfully been updated.' => 'Se actualizó con éxito el perfil del comentarista.',
    'Commenter profile could not be updated: [_1]' => 'No se pudo actualizar el perfil del comentarista: [_1]',

## lib/MT/CMS/Comment.pm
    'Edit Comment' => 'Editar comentario',
    '(untitled)' => '(sin título)',
    'No such commenter [_1].' => 'No existe el comentarista [_1].',
    'User \'[_1]\' trusted commenter \'[_2]\'.' => 'Usuario \'[_1]\' confió en el comentarista \'[_2]\'.',
    'User \'[_1]\' banned commenter \'[_2]\'.' => 'Usuario \'[_1]\' bloqueó al comentarista \'[_2]\'.',
    'User \'[_1]\' unbanned commenter \'[_2]\'.' => 'Usuario \'[_1]\' desbloqueó al comentarista \'[_2]\'.',
    'User \'[_1]\' untrusted commenter \'[_2]\'.' => 'Usuario \'[_1]\' desconfió del comentarista \'[_2]\'.',
    'The parent comment id was not specified.' => 'No se especificó el identificador del comentario raíz.',
    'The parent comment was not found.' => 'No se encontró el comentario padre.',
    'You cannot reply to unapproved comment.' => 'No puede responder a un comentario no aprobado.',
    'You cannot create a comment for an unpublished entry.' => 'No puede crear un comentario en una entrada sin publicar.',
    'You cannot reply to unpublished comment.' => 'No puede contestar a comentarios no publicados.',
    'Comment (ID:[_1]) by \'[_2]\' deleted by \'[_3]\' from entry \'[_4]\'' => 'Comentario (ID:[_1]) por \'[_2]\' borrado por \'[_3]\' de la entrada \'[_4]\'',
    'You do not have permission to approve this trackback.' => 'No tiene permiso para aprobar este trackback.',
    'The entry corresponding to this comment is missing.' => 'No se encuentra la entrada correspondiente a este comentario.',
    'You do not have permission to approve this comment.' => 'No tiene permisos para aprobar este comentario.',
    'Orphaned comment' => 'Comentario huérfano',

## lib/MT/Template/Tags/Commenter.pm
    'This \'[_1]\' tag has been deprecated. Please use \'[_2]\' instead.' => 'Esta etiqueta \'[_1]\' está obsoleta. Por favor, en su lugar use \'[_2]\'.',

## lib/MT/Template/Tags/Comment.pm
    'The MTCommentFields tag is no longer available.  Please include the [_1] template module instead.' => 'La etiqueta MTCommentFields ya no está disponible. Por favor, en su lugar, incluya el módulo de plantilla [_1].',
    'Comment Form' => 'Formulario de comentarios',
    'TypePad authentication is not enabled in this blog.  MTRemoteSignInLink can not be used.' => 'La autentificación de TypePad no está habilitada en este blog. No se puede usar MTRemoteSignInLink.',
    'To enable comment registration, you need to add a TypePad token in your weblog config or user profile.' => 'Para activar el registro de comentarios, debe añadir un token de TypePad a la configuración del weblog o al perfil de usuario.',
);

1;
